"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = copyStreamToBuffer;
function copyStreamToBuffer(inputStream, destinationBuffer) {
  return new Promise((resolve, reject) => {
    let index = 0;
    inputStream.on('data', chunk => {
      chunk.copy(destinationBuffer, index);
      index += chunk.length;
    });
    inputStream.on('end', () => resolve(index));
    inputStream.on('error', err => reject(err));
  });
}
//# sourceMappingURL=_copyStreamToBuffer.js.map