"use strict";

var _test = require("test");
var _assert = require("assert");
var _readableStream = require("readable-stream");
var _copyStreamToBuffer = _interopRequireDefault(require("./_copyStreamToBuffer.js"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
(0, _test.describe)('copyStreamToBuffer', () => {
  (0, _test.it)('should copy the stream to the buffer', async () => {
    const stream = new _readableStream.Readable({
      read() {
        this.push('hello');
        this.push(null);
      }
    });
    const buffer = Buffer.alloc(3);
    await (0, _copyStreamToBuffer.default)(stream, buffer);
    _assert.strict.equal(buffer.toString(), 'hel');
  });
});
//# sourceMappingURL=_copyStreamToBuffer.test.js.map