"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createBufferFromStream;
function createBufferFromStream(stream) {
  return new Promise((resolve, reject) => {
    const chunks = [];
    stream.on('data', chunk => chunks.push(chunk));
    stream.on('end', () => resolve(Buffer.concat(chunks)));
    stream.on('error', error => reject(error));
  });
}
//# sourceMappingURL=_createBufferFromStream.js.map