"use strict";

var _test = require("test");
var _assert = require("assert");
var _readableStream = require("readable-stream");
var _createBufferFromStream = _interopRequireDefault(require("./_createBufferFromStream.js"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
(0, _test.describe)('createBufferFromStream', () => {
  (0, _test.it)('should create a buffer from a stream', async () => {
    const stream = new _readableStream.Readable({
      read() {
        this.push('hello');
        this.push(null);
      }
    });
    const buffer = await (0, _createBufferFromStream.default)(stream);
    _assert.strict.equal(buffer.toString(), 'hello');
  });
});
//# sourceMappingURL=_createBufferFromStream.test.js.map