"use strict";

var _test = require("test");
var _assert = require("assert");
var _guessAwsRegion = _interopRequireDefault(require("./_guessAwsRegion.js"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
(0, _test.describe)('guessAwsRegion', () => {
  (0, _test.it)('should return region from AWS URL', async () => {
    const region = (0, _guessAwsRegion.default)('s3.test-region.amazonaws.com');
    _assert.strict.equal(region, 'test-region');
  });
  (0, _test.it)('should return default region if none is found is AWS URL', async () => {
    const region = (0, _guessAwsRegion.default)('s3.amazonaws.com');
    _assert.strict.equal(region, 'us-east-1');
  });
});
//# sourceMappingURL=_guessAwsRegion.test.js.map