"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resolveFromFile = exports.relativeFromFile = exports.normalize = exports.join = exports.dirname = exports.basename = void 0;
exports.split = split;
var _path = _interopRequireDefault(require("path"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const {
  basename,
  dirname,
  join,
  resolve,
  relative,
  sep
} = _path.default.posix;
exports.join = join;
exports.dirname = dirname;
exports.basename = basename;
const normalize = path => resolve('/', path);
exports.normalize = normalize;
function split(path) {
  const parts = normalize(path).split(sep);
  parts.shift();
  return parts;
}
const relativeFromFile = (file, path) => relative(dirname(file), path);
exports.relativeFromFile = relativeFromFile;
const resolveFromFile = (file, path) => resolve('/', dirname(file), path).slice(1);
exports.resolveFromFile = resolveFromFile;
//# sourceMappingURL=path.js.map