"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _xoRemoteParser = require("xo-remote-parser");
var _mount = _interopRequireDefault(require("./_mount"));
var _path = require("./path");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
class SmbHandler extends _mount.default {
  constructor(remote, opts) {
    const {
      domain = 'WORKGROUP',
      host,
      password,
      path,
      username
    } = (0, _xoRemoteParser.parse)(remote.url);
    super(remote, opts, {
      type: 'cifs',
      device: '//' + host + (0, _path.normalize)(path),
      options: `domain=${domain}`,
      env: {
        USER: username,
        PASSWD: password
      }
    });
  }
  get type() {
    return 'smb';
  }
}
exports.default = SmbHandler;
//# sourceMappingURL=smb.js.map