"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _getFromMap = _interopRequireDefault(require("./util/get-from-map"));
var _version = _interopRequireDefault(require("./version"));
var _index = _interopRequireDefault(require("./openflow-11/index"));
var _defaultHeaderScheme = _interopRequireDefault(require("./default-header-scheme"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const OPENFLOW = {
  [_version.default.openFlow11]: _index.default
};
var _default = {
  versions: _version.default,
  protocols: {
    [_version.default.openFlow11]: _index.default.protocol
  },
  pack: object => {
    const version = object.header.version;
    return (0, _getFromMap.default)(OPENFLOW, version, `Unsupported OpenFlow version: ${version}`).pack(object);
  },
  unpack: (buffer, offset = 0) => {
    const version = buffer.readUInt8(offset + _defaultHeaderScheme.default.offsets.version);
    return (0, _getFromMap.default)(OPENFLOW, version, `Unsupported OpenFlow version: ${version}`).unpack(buffer, offset);
  }
};
exports.default = _default;
//# sourceMappingURL=index.js.map