"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _getFromMap = _interopRequireDefault(require("../../util/get-from-map"));
var _output = _interopRequireDefault(require("./output"));
var _openflow = _interopRequireDefault(require("../openflow-11"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const ACTION = {
  [_openflow.default.actionType.output]: _output.default
};
var _default = {
  pack: (object, buffer = undefined, offset = 0) => {
    const {
      type
    } = object;
    return (0, _getFromMap.default)(ACTION, type, `Invalid action type: ${type}`).pack(object, buffer, offset);
  },
  unpack: (buffer, offset = 0) => {
    const type = buffer.readUInt16BE(offset + _openflow.default.offsets.actionHeader.type);
    return (0, _getFromMap.default)(ACTION, type, `Invalid action type: ${type}`).unpack(buffer, offset);
  }
};
exports.default = _default;
//# sourceMappingURL=action.js.map