"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _assert = _interopRequireDefault(require("assert"));
var _openflow = _interopRequireDefault(require("../openflow-11"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const OFFSETS = _openflow.default.offsets.actionOutput;
const PAD_LENGTH = 6;
var _default = {
  pack: (object, buffer = undefined, offset = 0) => {
    (0, _assert.default)(object.type === _openflow.default.actionType.output);
    object.len = _openflow.default.sizes.actionOutput;
    buffer = buffer !== undefined ? buffer : Buffer.alloc(object.len);
    buffer.writeUInt16BE(object.type, offset + OFFSETS.type);
    buffer.writeUInt16BE(object.len, offset + OFFSETS.len);
    buffer.writeUInt32BE(object.port, offset + OFFSETS.port);
    buffer.writeUInt16BE(object.max_len, offset + OFFSETS.maxLen);
    buffer.fill(0, offset + OFFSETS.pad, offset + OFFSETS.pad + PAD_LENGTH);
    return buffer;
  },
  unpack: (buffer, offset = 0) => {
    const object = {};
    object.type = buffer.readUInt16BE(offset + OFFSETS.type);
    (0, _assert.default)(object.type === _openflow.default.actionType.output);
    object.len = buffer.readUInt16BE(offset + OFFSETS.len);
    (0, _assert.default)(object.len === _openflow.default.sizes.actionOutput);
    object.port = buffer.readUInt32BE(offset + OFFSETS.port);
    object.max_len = buffer.readUInt16BE(offset + OFFSETS.maxLen);
    return object;
  }
};
exports.default = _default;
//# sourceMappingURL=output.js.map