"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _getFromMap = _interopRequireDefault(require("../util/get-from-map"));
var _echo = _interopRequireDefault(require("./message/echo"));
var _error = _interopRequireDefault(require("./message/error"));
var _hello = _interopRequireDefault(require("./message/hello"));
var _featuresRequest = _interopRequireDefault(require("./message/features-request"));
var _featuresReply = _interopRequireDefault(require("./message/features-reply"));
var _getConfigRequest = _interopRequireDefault(require("./message/get-config-request"));
var _switchConfig = _interopRequireDefault(require("./message/switch-config"));
var _flowMod = _interopRequireDefault(require("./message/flow-mod"));
var _openflow = _interopRequireDefault(require("./openflow-11"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const MESSAGE = {
  [_openflow.default.type.hello]: _hello.default,
  [_openflow.default.type.error]: _error.default,
  [_openflow.default.type.featuresRequest]: _featuresRequest.default,
  [_openflow.default.type.featuresReply]: _featuresReply.default,
  [_openflow.default.type.echoRequest]: _echo.default,
  [_openflow.default.type.echoReply]: _echo.default,
  [_openflow.default.type.getConfigRequest]: _getConfigRequest.default,
  [_openflow.default.type.getConfigReply]: _switchConfig.default,
  [_openflow.default.type.setConfig]: _switchConfig.default,
  [_openflow.default.type.flowMod]: _flowMod.default
};
var _default = {
  protocol: _openflow.default,
  pack: object => {
    const type = object.header.type;
    return (0, _getFromMap.default)(MESSAGE, type, `Invalid OpenFlow message type: ${type}`).pack(object);
  },
  unpack: (buffer, offset = 0) => {
    const type = buffer.readUInt8(offset + _openflow.default.offsets.header.type);
    return (0, _getFromMap.default)(MESSAGE, type, `Invalid OpenFlow message type: ${type}`).unpack(buffer, offset);
  }
};
exports.default = _default;
//# sourceMappingURL=index.js.map