"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _getFromMap = _interopRequireDefault(require("../../util/get-from-map"));
var _actions = _interopRequireDefault(require("./actions"));
var _openflow = _interopRequireDefault(require("../openflow-11"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const INSTRUCTION = {
  [_openflow.default.instructionType.writeActions]: _actions.default,
  [_openflow.default.instructionType.applyActions]: _actions.default,
  [_openflow.default.instructionType.clearActions]: _actions.default
};
const OFFSETS = _openflow.default.offsets.instruction;
var _default = {
  pack: (object, buffer = undefined, offset = 0) => {
    const {
      type
    } = object;
    return (0, _getFromMap.default)(INSTRUCTION, type, `Invalid instruction type: ${type}`).pack(object, buffer, offset);
  },
  unpack: (buffer = undefined, offset = 0) => {
    const type = buffer.readUInt16BE(offset + OFFSETS.type);
    return (0, _getFromMap.default)(INSTRUCTION, type, `Invalid instruction type: ${type}`).unpack(buffer, offset);
  }
};
exports.default = _default;
//# sourceMappingURL=instruction.js.map