"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _assert = _interopRequireDefault(require("assert"));
var _header = _interopRequireDefault(require("./header"));
var _openflow = _interopRequireDefault(require("../openflow-11"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const OFFSETS = _openflow.default.offsets.echo;
const TYPES = [_openflow.default.type.echoRequest, _openflow.default.type.echoReply];
var _default = {
  pack: object => {
    const {
      header,
      data
    } = object;
    (0, _assert.default)(TYPES.includes(header.type));
    const dataSize = data !== undefined ? data.length : 0;
    header.length = _openflow.default.sizes.header + dataSize;
    const buffer = Buffer.alloc(header.length);
    _header.default.pack(header, buffer, OFFSETS.header);
    if (dataSize > 0) {
      data.copy(buffer, OFFSETS.data, 0, dataSize);
    }
    return buffer;
  },
  unpack: (buffer, offset = 0) => {
    const header = _header.default.unpack(buffer, offset + OFFSETS.header);
    (0, _assert.default)(TYPES.includes(header.type));
    const object = {
      header
    };
    const dataSize = header.length - _openflow.default.sizes.header;
    if (dataSize > 0) {
      object.data = Buffer.alloc(dataSize);
      buffer.copy(object.data, 0, offset + OFFSETS.data, offset + OFFSETS.data + dataSize);
    }
    return object;
  }
};
exports.default = _default;
//# sourceMappingURL=echo.js.map