"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _assert = _interopRequireDefault(require("assert"));
var _openflow = _interopRequireDefault(require("../openflow-11"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const OFFSETS = _openflow.default.offsets.header;
var _default = {
  pack: (object, buffer = undefined, offset = 0) => {
    buffer = buffer !== undefined ? buffer : Buffer.alloc(_openflow.default.sizes.header);
    const {
      version,
      type,
      length,
      xid
    } = object;
    (0, _assert.default)(version === _openflow.default.version);
    (0, _assert.default)(Object.values(_openflow.default.type).includes(type));
    buffer.writeUInt8(version, offset + OFFSETS.version);
    buffer.writeUInt8(type, offset + OFFSETS.type);
    buffer.writeUInt16BE(length, offset + OFFSETS.length);
    buffer.writeUInt32BE(xid, offset + OFFSETS.xid);
    return buffer;
  },
  unpack: (buffer, offset = 0) => {
    const version = buffer.readUInt8(offset + OFFSETS.version);
    (0, _assert.default)(version === _openflow.default.version);
    const type = buffer.readUInt8(offset + OFFSETS.type);
    (0, _assert.default)(Object.values(_openflow.default.type).includes(type));
    const length = buffer.readUInt16BE(offset + OFFSETS.length);
    const xid = buffer.readUInt32BE(offset + OFFSETS.xid);
    return {
      version,
      type,
      length,
      xid
    };
  }
};
exports.default = _default;
//# sourceMappingURL=header.js.map