"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _assert = _interopRequireDefault(require("assert"));
var _header = _interopRequireDefault(require("./header"));
var _openflow = _interopRequireDefault(require("../openflow-11"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const OFFSETS = _openflow.default.offsets.switchConfig;
const TYPES = [_openflow.default.type.getConfigReply, _openflow.default.type.setConfig];
var _default = {
  pack: object => {
    const {
      header,
      flags,
      miss_send_len
    } = object;
    (0, _assert.default)(TYPES.includes(header.type));
    header.length = _openflow.default.sizes.switchConfig;
    const buffer = Buffer.alloc(header.length);
    _header.default.pack(header, buffer, OFFSETS.header);
    buffer.writeUInt16BE(flags, OFFSETS.flags);
    buffer.writeUInt16BE(miss_send_len, OFFSETS.missSendLen);
    return buffer;
  },
  unpack: (buffer, offset = 0) => {
    const header = _header.default.unpack(buffer, offset + OFFSETS.header);
    (0, _assert.default)(TYPES.includes(header.type));
    (0, _assert.default)(header.length === _openflow.default.sizes.switchConfig);
    const flags = buffer.readUInt16BE(offset + OFFSETS.flags);
    const miss_send_len = buffer.readUInt16BE(offset + OFFSETS.missSendLen);
    return {
      header,
      flags,
      miss_send_len
    };
  }
};
exports.default = _default;
//# sourceMappingURL=switch-config.js.map