"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _version = _interopRequireDefault(require("../version"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var _default = {
  version: _version.default.openFlow11,
  maxTableNameLen: 32,
  maxPortNameLen: 16,
  tcpPort: 6653,
  sslPort: 6653,
  ethAddrLen: 6,
  port: {
    max: 0xffffff00,
    inPort: 0xfffffff8,
    table: 0xfffffff9,
    normal: 0xfffffffa,
    flood: 0xfffffffb,
    all: 0xfffffffc,
    contorller: 0xfffffffd,
    local: 0xfffffffe,
    any: 0xffffffff
  },
  type: {
    hello: 0,
    error: 1,
    echoRequest: 2,
    echoReply: 3,
    experimenter: 4,
    featuresRequest: 5,
    featuresReply: 6,
    getConfigRequest: 7,
    getConfigReply: 8,
    setConfig: 9,
    packetIn: 10,
    flowRemoved: 11,
    portStatus: 12,
    packetOut: 13,
    flowMod: 14,
    groupMod: 15,
    portMod: 16,
    tableMod: 17,
    statsRequest: 18,
    statsReply: 19,
    barrierRequest: 20,
    barrierReply: 21,
    queueGetConfigRequest: 22,
    queueGetConfigReply: 23
  },
  defaultMissSendLen: 128,
  configFlags: {
    fragNormal: 0,
    fragDrop: 1 << 0,
    fragReasm: 1 << 1,
    fragMask: 3,
    invalidTtlToController: 1 << 2
  },
  tableConfig: {
    controller: 0,
    continue: 1 << 0,
    drop: 1 << 1,
    mask: 3
  },
  capabilities: {
    flowStats: 1 << 0,
    tableStats: 1 << 1,
    portStats: 1 << 2,
    groupStats: 1 << 3,
    ipReasm: 1 << 5,
    queueStats: 1 << 6,
    arpMatchIp: 1 << 7
  },
  portConfig: {
    down: 1 << 0,
    noRecv: 1 << 2,
    noFwd: 1 << 5,
    noPacketIn: 1 << 6
  },
  portState: {
    linkDown: 1 << 0,
    blocked: 1 << 1,
    live: 1 << 2
  },
  portFeatures: {
    f10MbHd: 1 << 0,
    f10MbFd: 1 << 1,
    f100MbHd: 1 << 2,
    f100MbFd: 1 << 3,
    f1GbHd: 1 << 4,
    f1GbFd: 1 << 5,
    f10GbFd: 1 << 6,
    f40GbFd: 1 << 7,
    f100GbFd: 1 << 8,
    f1TbFd: 1 << 9,
    other: 1 << 10,
    copper: 1 << 11,
    fiber: 1 << 12,
    autoneg: 1 << 13,
    pause: 1 << 14,
    pauseAsym: 1 << 15
  },
  portReason: {
    add: 0,
    delete: 1,
    modify: 2
  },
  packetInReason: {
    noMatch: 0,
    action: 1
  },
  actionType: {
    output: 0,
    setVlanId: 1,
    setVlanPcp: 2,
    setDlSrc: 3,
    setDlDst: 4,
    setNwSrc: 5,
    setNwDst: 6,
    setNwTos: 7,
    setNwEcn: 8,
    setTpSrc: 9,
    setTpDst: 10,
    copyTtlOut: 11,
    copyTtlIn: 12,
    setMplsLabel: 13,
    setMplsTc: 14,
    setMplsTtl: 15,
    decMplsTtl: 16,
    pushVlan: 17,
    popVlan: 18,
    pushMpls: 19,
    popMpls: 20,
    setQueue: 21,
    group: 22,
    setNwTtl: 23,
    decNwTtl: 24,
    experimenter: 0xffff
  },
  flowModCommand: {
    add: 0,
    modify: 1,
    modifyStrict: 2,
    delete: 3,
    deleteStrict: 4
  },
  groupModCommand: {
    add: 0,
    modify: 1,
    delete: 2
  },
  flowWildcards: {
    inPort: 1 << 0,
    dlVlan: 1 << 1,
    dlVlanPcp: 1 << 2,
    dlType: 1 << 3,
    nwTos: 1 << 4,
    nwProto: 1 << 5,
    tpSrc: 1 << 6,
    tpDst: 1 << 7,
    mplsLabel: 1 << 8,
    mplsTc: 1 << 9,
    all: (1 << 10) - 1
  },
  dlType: {
    ip: 0x0800,
    arp: 0x0806,
    eth2Cutoff: 0x0600,
    notEthType: 0x05ff
  },
  nwProto: {
    icmp: 1,
    tcp: 6,
    udp: 17
  },
  vlanId: {
    any: 0xfffe,
    none: 0xffff
  },
  matchType: {
    standard: 0
  },
  flowPermanent: 0,
  defaultPriority: 0x8000,
  instructionType: {
    goToTable: 1,
    writeMetadata: 2,
    writeActions: 3,
    applyActions: 4,
    clearActions: 5,
    experimenter: 0xffff
  },
  flowModFlags: {
    sendFlowRem: 1 << 0,
    checkOverlap: 1 << 1
  },
  group: {
    max: 0xffffff00,
    all: 0xfffffffc,
    any: 0xffffffff
  },
  groupType: {
    all: 0,
    select: 1,
    indirect: 2,
    ff: 3
  },
  flowRemovedReason: {
    idleTimeout: 0,
    hardTimeout: 1,
    delete: 2,
    groupDelete: 3
  },
  errorType: {
    helloFailed: 0,
    badRequest: 1,
    badAction: 2,
    badInstruction: 3,
    badMatch: 4,
    flowModFailed: 5,
    groupModFailed: 6,
    portModFailed: 7,
    tableModFailed: 8,
    queueOpFailed: 9,
    switchConfigFailed: 10
  },
  helloFailedCode: {
    incompatible: 0,
    eperm: 1
  },
  badRequestCode: {
    badVersion: 0,
    badType: 1,
    badStat: 2,
    badExperimenter: 3,
    badSubtype: 4,
    eperm: 5,
    badLen: 6,
    bufferEmpty: 7,
    bufferUnknown: 8,
    badTableId: 9
  },
  badActionCode: {
    badType: 0,
    badLen: 1,
    badExperimenter: 2,
    badExperimenterType: 3,
    badOutPort: 4,
    badArgument: 5,
    eperm: 6,
    tooMany: 7,
    badQueue: 8,
    badOutGroup: 9,
    matchInconsistent: 10,
    unsuportedOrder: 11,
    badTag: 12
  },
  badInstructionCode: {
    unknownInst: 0,
    unsupInst: 1,
    badTableId: 2,
    unsupMetadata: 3,
    unsupMetadataMask: 4,
    unsupExpInst: 5
  },
  badMatchCode: {
    badType: 0,
    badLen: 1,
    badTag: 2,
    badDlAddrMask: 3,
    badNwAddrMask: 4,
    badWildcards: 5,
    badField: 6,
    badValue: 7
  },
  flowModFailedCode: {
    unknown: 0,
    tableFull: 1,
    badTableId: 2,
    overlap: 3,
    eperm: 4,
    badTimeout: 5,
    badCommand: 6
  },
  groupModFailedCode: {
    groupExists: 0,
    invalidGroup: 1,
    weightUnsupported: 2,
    outOfGroups: 3,
    outOfBuckets: 4,
    chainingUnsupported: 5,
    watchUnsupported: 6,
    loop: 7,
    unknownGroup: 8
  },
  portModFailedCode: {
    badPort: 0,
    badHwAddr: 1,
    badConfig: 2,
    badAdvertise: 3
  },
  tableModFailedCode: {
    badTable: 0,
    badConfig: 1
  },
  queueOpFailedCode: {
    badPort: 0,
    badQueue: 1,
    eperm: 2
  },
  switchConfigFailedCode: {
    badFlags: 0,
    badLen: 1
  },
  statsType: {
    descr: 0,
    flow: 1,
    aggregate: 2,
    table: 3,
    port: 4,
    queue: 5,
    group: 6,
    groupDesc: 7,
    experimenter: 0xffff
  },
  statsReplyFlags: {
    replyMore: 1 << 0
  },
  descStrLen: 256,
  serialNumLen: 32,
  flowMatchFields: {
    inPort: 1 << 0,
    dlVlan: 1 << 1,
    dlVlanPcp: 1 << 2,
    dlType: 1 << 3,
    nwTos: 1 << 4,
    nwProto: 1 << 5,
    tpSrc: 1 << 6,
    tpDst: 1 << 7,
    mplsLabel: 1 << 8,
    mplsTc: 1 << 9,
    type: 1 << 10,
    dlSrc: 1 << 11,
    dlDst: 1 << 12,
    nwSrc: 1 << 13,
    nwDst: 1 << 14,
    metadata: 1 << 15
  },
  queueAll: 0xffffffff,
  queueMinRateUncfg: 0xffff,
  queueProperties: {
    none: 0,
    minRate: 1
  },
  table: {
    max: 254,
    all: 255
  },
  sizes: {
    header: 8,
    hello: 8,
    featuresRequest: 8,
    switchConfig: 12,
    tableMod: 16,
    port: 64,
    switchFeatures: 32,
    portStatus: 80,
    portMod: 40,
    packetIn: 24,
    actionOutput: 16,
    actionVlanId: 8,
    actionVlanPcp: 8,
    actionDlAddr: 16,
    actionNwAddr: 8,
    actionTpPort: 8,
    actionNwTos: 8,
    actionNwEcn: 8,
    actionMplsLabel: 8,
    actionMplsTc: 8,
    actionMplsTtl: 8,
    actionPush: 8,
    actionPopMpls: 8,
    actionGroup: 8,
    actionNwTtl: 8,
    actionExperimenterHeader: 8,
    actionHeader: 8,
    packetOut: 24,
    match: 88,
    instruction: 8,
    instructionGotoTable: 8,
    instructionWriteMetadata: 24,
    instructionActions: 8,
    instructionExperimenter: 8,
    flowMod: 136,
    bucket: 16,
    groupMod: 16,
    flowRemoved: 136,
    errorMsg: 12,
    statsRequest: 16,
    statsReply: 16,
    descStats: 1056,
    flowStatsRequest: 120,
    flowStats: 136,
    aggregateStatsRequest: 120,
    aggregateStatsReply: 24,
    tableStats: 88,
    portStatsRequest: 8,
    portStats: 104,
    groupStatsRequest: 8,
    bucketCounter: 16,
    groupStats: 32,
    groupDescStats: 8,
    experimenterHeader: 16,
    queuePropHeader: 8,
    queuePropMinRate: 16,
    packetQueue: 8,
    queueGetConfigRequest: 16,
    queueGetConfigReply: 16,
    actionSetQueue: 8,
    queueStatsRequest: 8,
    queueStats: 32
  },
  offsets: {
    header: {
      version: 0,
      type: 1,
      length: 2,
      xid: 4
    },
    hello: {
      header: 0
    },
    echo: {
      header: 0,
      data: 8
    },
    switchConfig: {
      header: 0,
      flags: 8,
      missSendLen: 10
    },
    tableMod: {
      header: 0,
      tableId: 8,
      pad: 9,
      config: 12
    },
    port: {
      portNo: 0,
      pad: 4,
      hwAddr: 8,
      pad2: 14,
      name: 16,
      config: 32,
      state: 36,
      curr: 40,
      advertised: 44,
      supported: 48,
      peer: 52,
      currSpeed: 56,
      maxSpeed: 60
    },
    switchFeatures: {
      header: 0,
      datapathId: 8,
      nBuffers: 16,
      nTables: 20,
      pad: 21,
      capabilities: 24,
      reserved: 28,
      ports: 32
    },
    portStatus: {
      header: 0,
      reason: 8,
      pad: 9,
      desc: 16
    },
    portMod: {
      header: 0,
      portNo: 8,
      pad: 12,
      hwAddr: 16,
      pad2: 22,
      config: 24,
      mask: 28,
      advertise: 32,
      pad3: 36
    },
    packetIn: {
      header: 0,
      bufferId: 8,
      inPort: 12,
      inPhyPort: 16,
      totalLen: 20,
      reason: 22,
      tableId: 23,
      data: 24
    },
    actionOutput: {
      type: 0,
      len: 2,
      port: 4,
      maxLen: 8,
      pad: 10
    },
    actionVlanId: {
      type: 0,
      len: 2,
      vlanId: 4,
      pad: 6
    },
    actionVlanPcp: {
      type: 0,
      len: 2,
      vlanPcp: 4,
      pad: 5
    },
    actionDlAddr: {
      type: 0,
      len: 2,
      dlAddr: 4,
      pad: 10
    },
    actionNwAddr: {
      type: 0,
      len: 2,
      nwAddr: 4
    },
    actionTpPort: {
      type: 0,
      len: 2,
      tpPort: 4,
      pad: 6
    },
    actionNwTos: {
      type: 0,
      len: 2,
      nwTos: 4,
      pad: 5
    },
    actionNwEcn: {
      type: 0,
      len: 2,
      nwEcn: 4,
      pad: 5
    },
    actionMplsLabel: {
      type: 0,
      len: 2,
      mplsLabel: 4
    },
    actionMplsTc: {
      type: 0,
      len: 2,
      mplsTc: 4,
      pad: 5
    },
    actionMplsTtl: {
      type: 0,
      len: 2,
      mplsTtl: 4,
      pad: 5
    },
    actionPush: {
      type: 0,
      len: 2,
      ethertype: 4,
      pad: 6
    },
    actionPopMpls: {
      type: 0,
      len: 2,
      ethertype: 4,
      pad: 6
    },
    actionGroup: {
      type: 0,
      len: 2,
      groupId: 4
    },
    actionNwTtl: {
      type: 0,
      len: 2,
      nwTtl: 4,
      pad: 5
    },
    actionExperimenterHeader: {
      type: 0,
      len: 2,
      experimenter: 4
    },
    actionHeader: {
      type: 0,
      len: 2,
      pad: 4
    },
    packetOut: {
      header: 0,
      bufferId: 8,
      inPort: 12,
      actionsLen: 16,
      pad: 18,
      actions: 24
    },
    match: {
      type: 0,
      length: 2,
      inPort: 4,
      wildcards: 8,
      dlSrc: 12,
      dlSrcMask: 18,
      dlDst: 24,
      dlDstMask: 30,
      dlVlan: 36,
      dlVlanPcp: 38,
      pad1: 39,
      dlType: 40,
      nwTos: 42,
      nwProto: 43,
      nwSrc: 44,
      nwSrcMask: 48,
      nwDst: 52,
      nwDstMask: 56,
      tpSrc: 60,
      tpDst: 62,
      mplsLabel: 64,
      mplsTc: 68,
      pad2: 69,
      metadata: 72,
      metadataMask: 80
    },
    instruction: {
      type: 0,
      len: 2,
      pad: 4
    },
    instructionGotoTable: {
      type: 0,
      len: 2,
      tableId: 4,
      pad: 5
    },
    instructionWriteMetadata: {
      type: 0,
      len: 2,
      pad: 4,
      metadata: 8,
      metadataMask: 16
    },
    instructionActions: {
      type: 0,
      len: 2,
      pad: 4,
      actions: 8
    },
    instructionExperimenter: {
      type: 0,
      len: 2,
      experimenter: 4
    },
    flowMod: {
      header: 0,
      cookie: 8,
      cookieMask: 16,
      tableId: 24,
      command: 25,
      idleTimeout: 26,
      hardTimeout: 28,
      priority: 30,
      bufferId: 32,
      outPort: 36,
      outGroup: 40,
      flags: 44,
      pad: 46,
      match: 48,
      instructions: 136
    },
    bucket: {
      len: 0,
      weight: 2,
      watchPort: 4,
      watchGroup: 8,
      pad: 12,
      actions: 16
    },
    groupMod: {
      header: 0,
      command: 8,
      type: 10,
      pad: 11,
      groupId: 12,
      buckets: 16
    },
    flowRemoved: {
      header: 0,
      cookie: 8,
      priority: 16,
      reason: 18,
      tableId: 19,
      durationSec: 20,
      durationNsec: 24,
      idleTimeout: 28,
      pad2: 30,
      packetCount: 32,
      byteCount: 40,
      match: 48
    },
    errorMsg: {
      header: 0,
      type: 8,
      code: 10,
      data: 12
    },
    statsRequest: {
      header: 0,
      type: 8,
      flags: 10,
      pad: 12,
      body: 16
    },
    statsReply: {
      header: 0,
      type: 8,
      flags: 10,
      pad: 12,
      body: 16
    },
    descStats: {
      mfrDesc: 0,
      hwDesc: 256,
      swDesc: 512,
      serialNum: 768,
      dpDesc: 800
    },
    flowStatsRequest: {
      tableId: 0,
      pad: 1,
      outPort: 4,
      outGroup: 8,
      pad2: 12,
      cookie: 16,
      cookieMask: 24,
      match: 32
    },
    flowStats: {
      length: 0,
      tableId: 2,
      pad: 3,
      durationSec: 4,
      durationNsec: 8,
      priority: 12,
      idleTimeout: 14,
      hardTimeout: 16,
      pad2: 18,
      cookie: 24,
      packetCount: 32,
      byteCount: 40,
      match: 48,
      instructions: 136
    },
    aggregateStatsRequest: {
      tableId: 0,
      pad: 1,
      outPort: 4,
      outGroup: 8,
      pad2: 12,
      cookie: 16,
      cookieMask: 24,
      match: 32
    },
    aggregateStatsReply: {
      packetCount: 0,
      byteCount: 8,
      flowCount: 16,
      pad: 20
    },
    tableStats: {
      tableId: 0,
      pad: 1,
      name: 8,
      wildcards: 40,
      match: 44,
      instructions: 48,
      writeActions: 52,
      applyActions: 56,
      config: 60,
      maxEntries: 64,
      activeCount: 68,
      lookupCount: 72,
      matchedCount: 80
    },
    portStatsRequest: {
      portNo: 0,
      pad: 4
    },
    portStats: {
      portNo: 0,
      pad: 4,
      rxPackets: 8,
      txPackets: 16,
      rxBytes: 24,
      txBytes: 32,
      rxDropped: 40,
      txDropped: 48,
      rxErrors: 56,
      txErrors: 64,
      rxFrameErr: 72,
      rxOverErr: 80,
      rxCrcErr: 88,
      collisions: 96
    },
    groupStatsRequest: {
      groupId: 0,
      pad: 4
    },
    bucketCounter: {
      packetCount: 0,
      byteCount: 8
    },
    groupStats: {
      length: 0,
      pad: 2,
      groupId: 4,
      refCount: 8,
      pad2: 12,
      packetCount: 16,
      byteCount: 24,
      bucketStats: 32
    },
    groupDescStats: {
      length: 0,
      type: 2,
      pad: 3,
      groupId: 4,
      buckets: 8
    },
    experimenterHeader: {
      header: 0,
      experimenter: 8,
      pad: 12
    },
    queuePropHeader: {
      property: 0,
      len: 2,
      pad: 4
    },
    queuePropMinRate: {
      propHeader: 0,
      rate: 8,
      pad: 10
    },
    packetQueue: {
      queueId: 0,
      len: 4,
      pad: 6,
      properties: 8
    },
    queueGetConfigRequest: {
      header: 0,
      port: 8,
      pad: 12
    },
    queueGetConfigReply: {
      header: 0,
      port: 8,
      pad: 12,
      queues: 16
    },
    actionSetQueue: {
      type: 0,
      len: 2,
      queueId: 4
    },
    queueStatsRequest: {
      portNo: 0,
      queueId: 4
    },
    queueStats: {
      portNo: 0,
      queueId: 4,
      txBytes: 8,
      txPackets: 16,
      txErrors: 24
    }
  }
};
exports.default = _default;
//# sourceMappingURL=openflow-11.js.map