"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = parse;
var _assert = _interopRequireDefault(require("assert"));
var _index = _interopRequireDefault(require("./index"));
var _defaultHeaderScheme = _interopRequireDefault(require("./default-header-scheme"));
var _readChunk = require("@vates/read-chunk");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _awaitAsyncGenerator(value) { return new _OverloadYield(value, 0); }
function _wrapAsyncGenerator(fn) { return function () { return new _AsyncGenerator(fn.apply(this, arguments)); }; }
function _AsyncGenerator(gen) { var front, back; function resume(key, arg) { try { var result = gen[key](arg), value = result.value, overloaded = value instanceof _OverloadYield; Promise.resolve(overloaded ? value.v : value).then(function (arg) { if (overloaded) { var nextKey = "return" === key ? "return" : "next"; if (!value.k || arg.done) return resume(nextKey, arg); arg = gen[nextKey](arg).value; } settle(result.done ? "return" : "normal", arg); }, function (err) { resume("throw", err); }); } catch (err) { settle("throw", err); } } function settle(type, value) { switch (type) { case "return": front.resolve({ value: value, done: !0 }); break; case "throw": front.reject(value); break; default: front.resolve({ value: value, done: !1 }); } (front = front.next) ? resume(front.key, front.arg) : back = null; } this._invoke = function (key, arg) { return new Promise(function (resolve, reject) { var request = { key: key, arg: arg, resolve: resolve, reject: reject, next: null }; back ? back = back.next = request : (front = back = request, resume(key, arg)); }); }, "function" != typeof gen.return && (this.return = void 0); }
_AsyncGenerator.prototype["function" == typeof Symbol && Symbol.asyncIterator || "@@asyncIterator"] = function () { return this; }, _AsyncGenerator.prototype.next = function (arg) { return this._invoke("next", arg); }, _AsyncGenerator.prototype.throw = function (arg) { return this._invoke("throw", arg); }, _AsyncGenerator.prototype.return = function (arg) { return this._invoke("return", arg); };
function _OverloadYield(value, kind) { this.v = value, this.k = kind; }
function parse(_x) {
  return _parse.apply(this, arguments);
}
function _parse() {
  _parse = _wrapAsyncGenerator(function* (socket) {
    let buffer = Buffer.alloc(1024);
    let data;
    while ((data = yield _awaitAsyncGenerator((0, _readChunk.readChunk)(socket, _defaultHeaderScheme.default.size))) !== null) {
      const msgSize = data.readUInt16BE(_defaultHeaderScheme.default.offsets.length);
      data.copy(buffer, 0, 0, _defaultHeaderScheme.default.size);
      if (buffer.length < msgSize) {
        buffer = resize(buffer, msgSize);
      }
      if (msgSize > _defaultHeaderScheme.default.size) {
        data = yield _awaitAsyncGenerator((0, _readChunk.readChunk)(socket, msgSize - _defaultHeaderScheme.default.size));
        _assert.default.notStrictEqual(data, null);
        data.copy(buffer, _defaultHeaderScheme.default.size, 0, msgSize - _defaultHeaderScheme.default.size);
      }
      yield _index.default.unpack(buffer);
    }
  });
  return _parse.apply(this, arguments);
}
function resize(buffer, size) {
  let newLength = buffer.length;
  do {
    newLength *= 2;
  } while (newLength < size);
  const newBuffer = Buffer.alloc(newLength);
  buffer.copy(newBuffer);
  return newBuffer;
}
//# sourceMappingURL=parse-socket.js.map