import { BaseError } from 'make-error';
import { JsonRpcErrorSchema } from './json-rpc.type';
export declare class JsonRpcError extends BaseError {
    readonly code: number;
    readonly data: undefined | string;
    constructor(message?: string, code?: number, data?: string);
    toJsonRpcError(): JsonRpcErrorSchema;
}
export declare class InvalidJson extends JsonRpcError {
    constructor();
}
export declare class InvalidRequest extends JsonRpcError {
    constructor(message?: string);
}
export declare class MethodNotFound extends JsonRpcError {
    constructor(method?: string);
}
export declare class InvalidParameters extends JsonRpcError {
    constructor(data?: string);
}
