"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _makeError = require("make-error");
class XapiError extends _makeError.BaseError {
  static wrap(error) {
    let code, params;
    if (Array.isArray(error)) {
      ;
      [code, ...params] = error;
    } else {
      code = error.message;
      params = error.data;
      if (!Array.isArray(params)) {
        params = [];
      }
    }
    return new XapiError(code, params);
  }
  constructor(code, params) {
    super(`${code}(${params.join(', ')})`);
    this.code = code;
    this.params = params;
    this.call = undefined;
    this.url = undefined;
    this.task = undefined;
  }
}
exports.default = XapiError;
//# sourceMappingURL=_XapiError.js.map