"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _promiseToolbox = require("promise-toolbox");
var _XapiError = _interopRequireDefault(require("./_XapiError"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var _default = task => {
  const {
    status
  } = task;
  if (status === 'cancelled') {
    return Promise.reject(new _promiseToolbox.Cancel('task canceled'));
  }
  if (status === 'failure') {
    const error = _XapiError.default.wrap(task.error_info);
    error.task = task;
    return Promise.reject(error);
  }
  if (status === 'success') {
    return Promise.resolve(task.result);
  }
};
exports.default = _default;
//# sourceMappingURL=_getTaskResult.js.map