"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
const URL_RE = /^(?:(https?:)\/*)?(?:(([^:]*)(?::([^@]*))?)@)?(?:\[([^\]]+)\]|([^:/]+))(?::([0-9]+))?(\/[^?#]*)?$/;
var _default = url => {
  const matches = URL_RE.exec(url);
  if (matches === null) {
    throw new Error('invalid URL: ' + url);
  }
  const [, protocol = 'https:', auth, username = '', password = '', ipv6, hostname = ipv6, port, pathname = '/'] = matches;
  const parsedUrl = {
    protocol,
    hostname,
    port,
    pathname,
    auth
  };
  if (username !== '') {
    parsedUrl.username = decodeURIComponent(username);
  }
  if (password !== '') {
    parsedUrl.password = decodeURIComponent(password);
  }
  return parsedUrl;
};
exports.default = _default;
//# sourceMappingURL=_parseUrl.js.map