"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _jsonRpc = _interopRequireDefault(require("./json-rpc"));
var _UnsupportedTransport = _interopRequireDefault(require("./_UnsupportedTransport"));
var _xmlRpc = _interopRequireDefault(require("./xml-rpc"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const factories = [_jsonRpc.default, _xmlRpc.default];
const {
  length
} = factories;
var _default = opts => {
  let i = 0;
  let call;
  function create() {
    const current = factories[i++](opts);
    if (i < length) {
      const currentI = i;
      call = (method, args) => current(method, args).catch(error => {
        if (error instanceof _UnsupportedTransport.default) {
          if (currentI === i) {
            create();
          }
          return call(method, args);
        }
        throw error;
      });
    } else {
      call = current;
    }
  }
  create();
  return (method, args) => call(method, args);
};
exports.default = _default;
//# sourceMappingURL=auto.js.map