"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _httpRequestPlus = _interopRequireDefault(require("http-request-plus"));
var _jsonRpcProtocol = require("json-rpc-protocol");
var _XapiError = _interopRequireDefault(require("../_XapiError"));
var _UnsupportedTransport = _interopRequireDefault(require("./_UnsupportedTransport"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var _default = ({
  secureOptions,
  url,
  agent
}) => {
  url = new URL('./jsonrpc', Object.assign(new URL('http://localhost'), url));
  return async function (method, args) {
    const res = await (0, _httpRequestPlus.default)(url, {
      ...secureOptions,
      body: _jsonRpcProtocol.format.request(0, method, args),
      headers: {
        Accept: 'application/json',
        'Content-Type': 'application/json'
      },
      method: 'POST',
      agent
    });
    if (res.headers['content-type'] !== 'application/json') {
      throw new _UnsupportedTransport.default();
    }
    const response = (0, _jsonRpcProtocol.parse)(await res.text());
    if (response.type === 'response') {
      return response.result;
    }
    throw _XapiError.default.wrap(response.error);
  };
};
exports.default = _default;
//# sourceMappingURL=json-rpc.js.map