"use strict";

var _forEach = _interopRequireDefault(require("lodash/forEach.js"));
var _collection = require("./collection");
var _view = require("./view");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const users = new _collection.Collection();
users.getKey = user => user.name;
users.add({
  name: 'bob'
});
users.add({
  name: 'clara',
  active: true
});
users.add({
  name: 'ophelia'
});
users.add({
  name: 'Steve',
  active: true
});
const activeUsers = new _view.View(users, 'active');
activeUsers.on('add', users => {
  (0, _forEach.default)(users, (_, id) => {
    console.log('+ active user:', id);
  });
});
activeUsers.on('remove', users => {
  (0, _forEach.default)(users, (_, id) => {
    console.log('- active user:', id);
  });
});
setTimeout(function () {
  console.log('-----');
  users.set({
    name: 'ophelia',
    active: true
  });
  users.set({
    name: 'Steve'
  });
}, 10);
//# sourceMappingURL=view.example.js.map