"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.configurationSchema = void 0;
var _asyncIteratorToStream = _interopRequireDefault(require("async-iterator-to-stream"));
var _apiErrors = require("xo-common/api-errors");
var _zlib = require("zlib");
var _log = require("@xen-orchestra/log");
var _cron = require("@xen-orchestra/cron");
var _promiseToolbox = require("promise-toolbox");
var _readableStream = require("readable-stream");
var _auditCore = require("@xen-orchestra/audit-core");
const _excluded = ["userId", "userIp", "userName"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _awaitAsyncGenerator(value) { return new _OverloadYield(value, 0); }
function _wrapAsyncGenerator(fn) { return function () { return new _AsyncGenerator(fn.apply(this, arguments)); }; }
function _AsyncGenerator(gen) { var front, back; function resume(key, arg) { try { var result = gen[key](arg), value = result.value, overloaded = value instanceof _OverloadYield; Promise.resolve(overloaded ? value.v : value).then(function (arg) { if (overloaded) { var nextKey = "return" === key ? "return" : "next"; if (!value.k || arg.done) return resume(nextKey, arg); arg = gen[nextKey](arg).value; } settle(result.done ? "return" : "normal", arg); }, function (err) { resume("throw", err); }); } catch (err) { settle("throw", err); } } function settle(type, value) { switch (type) { case "return": front.resolve({ value: value, done: !0 }); break; case "throw": front.reject(value); break; default: front.resolve({ value: value, done: !1 }); } (front = front.next) ? resume(front.key, front.arg) : back = null; } this._invoke = function (key, arg) { return new Promise(function (resolve, reject) { var request = { key: key, arg: arg, resolve: resolve, reject: reject, next: null }; back ? back = back.next = request : (front = back = request, resume(key, arg)); }); }, "function" != typeof gen.return && (this.return = void 0); }
_AsyncGenerator.prototype["function" == typeof Symbol && Symbol.asyncIterator || "@@asyncIterator"] = function () { return this; }, _AsyncGenerator.prototype.next = function (arg) { return this._invoke("next", arg); }, _AsyncGenerator.prototype.throw = function (arg) { return this._invoke("throw", arg); }, _AsyncGenerator.prototype.return = function (arg) { return this._invoke("return", arg); };
function _OverloadYield(value, kind) { this.v = value, this.k = kind; }
function _asyncIterator(iterable) { var method, async, sync, retry = 2; for ("undefined" != typeof Symbol && (async = Symbol.asyncIterator, sync = Symbol.iterator); retry--;) { if (async && null != (method = iterable[async])) return method.call(iterable); if (sync && null != (method = iterable[sync])) return new AsyncFromSyncIterator(method.call(iterable)); async = "@@asyncIterator", sync = "@@iterator"; } throw new TypeError("Object is not async iterable"); }
function AsyncFromSyncIterator(s) { function AsyncFromSyncIteratorContinuation(r) { if (Object(r) !== r) return Promise.reject(new TypeError(r + " is not an object.")); var done = r.done; return Promise.resolve(r.value).then(function (value) { return { value: value, done: done }; }); } return AsyncFromSyncIterator = function AsyncFromSyncIterator(s) { this.s = s, this.n = s.next; }, AsyncFromSyncIterator.prototype = { s: null, n: null, next: function next() { return AsyncFromSyncIteratorContinuation(this.n.apply(this.s, arguments)); }, return: function _return(value) { var ret = this.s.return; return void 0 === ret ? Promise.resolve({ value: value, done: !0 }) : AsyncFromSyncIteratorContinuation(ret.apply(this.s, arguments)); }, throw: function _throw(value) { var thr = this.s.return; return void 0 === thr ? Promise.reject(value) : AsyncFromSyncIteratorContinuation(thr.apply(this.s, arguments)); } }, new AsyncFromSyncIterator(s); }
const log = (0, _log.createLogger)('xo:xo-server-audit');
const DEFAULT_BLOCKED_LIST = {
  'acl.get': true,
  'acl.getCurrentPermissions': true,
  'audit.checkIntegrity': true,
  'audit.clean': true,
  'audit.deleteRange': true,
  'audit.generateFingerprint': true,
  'audit.getRecords': true,
  'backup.list': true,
  'backupNg.getAllJobs': true,
  'backupNg.getAllLogs': true,
  'backupNg.listVmBackups': true,
  'cloud.getResourceCatalog': true,
  'cloudConfig.getAll': true,
  'group.getAll': true,
  'host.isHostServerTimeConsistent': true,
  'host.isHyperThreadingEnabled': true,
  'host.stats': true,
  'ipPool.getAll': true,
  'job.getAll': true,
  'log.get': true,
  'metadataBackup.getAllJobs': true,
  'network.getBondModes': true,
  'pif.getIpv4ConfigurationModes': true,
  'plugin.get': true,
  'pool.listMissingPatches': true,
  'proxy.getAll': true,
  'proxy.getApplianceUpdaterState': true,
  'remote.getAll': true,
  'remote.getAllInfo': true,
  'remote.list': true,
  'resourceSet.getAll': true,
  'role.getAll': true,
  'schedule.getAll': true,
  'server.getAll': true,
  'session.getUser': true,
  'session.signIn': true,
  'sr.getAllUnhealthyVdiChainsLength': true,
  'sr.getVdiChainsInfo': true,
  'sr.stats': true,
  'system.getMethodsInfo': true,
  'system.getServerTimezone': true,
  'system.getServerVersion': true,
  'user.getAll': true,
  'vm.getHaValues': true,
  'vm.stats': true,
  'xo.getAllObjects': true,
  'xoa.check': true,
  'xoa.clearCheckCache': true,
  'xoa.getApplianceInfo': true,
  'xoa.getHVSupportedVersions': true,
  'xoa.licenses.get': true,
  'xoa.licenses.getAll': true,
  'xoa.licenses.getSelf': true,
  'xoa.supportTunnel.getState': true,
  'xosan.checkSrCurrentState': true,
  'xosan.computeXosanPossibleOptions': true,
  'xosan.getVolumeInfo': true
};
const LAST_ID = 'lastId';
class Db extends _auditCore.Storage {
  constructor(db) {
    super();
    this._db = db;
  }
  put(record) {
    var _this = this;
    return _asyncToGenerator(function* () {
      yield _this._db.put(record.id, record);
    })();
  }
  del(id) {
    var _this2 = this;
    return _asyncToGenerator(function* () {
      yield _this2._db.del(id);
    })();
  }
  get(id) {
    return this._db.get(id).catch(error => {
      if (!error.notFound) {
        throw error;
      }
    });
  }
  setLastId(id) {
    var _this3 = this;
    return _asyncToGenerator(function* () {
      yield _this3._db.put(LAST_ID, id);
    })();
  }
  getLastId() {
    return this.get(LAST_ID);
  }
  clean() {
    var _this4 = this;
    return _asyncToGenerator(function* () {
      const db = _this4._db;
      yield db.del(LAST_ID);
      return new Promise((resolve, reject) => {
        let count = 1;
        const cb = () => {
          if (--count === 0) {
            resolve();
          }
        };
        const deleteEntry = key => {
          ++count;
          db.del(key, cb);
        };
        db.createKeyStream().on('data', deleteEntry).on('end', cb).on('error', reject);
      });
    })();
  }
}
const configurationSchema = {
  type: 'object',
  properties: {
    active: {
      description: 'Whether to save user actions in the audit log',
      type: 'boolean'
    }
  }
};
exports.configurationSchema = configurationSchema;
const NAMESPACE = 'audit';
class AuditXoPlugin {
  constructor({
    staticConfig,
    xo
  }) {
    var _staticConfig$lastHas;
    this._blockedList = _objectSpread(_objectSpread({}, DEFAULT_BLOCKED_LIST), staticConfig.blockedList);
    this._cleaners = [];
    this._xo = xo;
    const _ref2 = (_staticConfig$lastHas = staticConfig.lastHashUpload) !== null && _staticConfig$lastHas !== void 0 ? _staticConfig$lastHas : {},
      _ref2$enabled = _ref2.enabled,
      enabled = _ref2$enabled === void 0 ? true : _ref2$enabled,
      _ref2$schedule = _ref2.schedule,
      _ref2$schedule2 = _ref2$schedule === void 0 ? {} : _ref2$schedule,
      _ref2$schedule2$cron = _ref2$schedule2.cron,
      cron = _ref2$schedule2$cron === void 0 ? '0 6 * * *' : _ref2$schedule2$cron,
      timezone = _ref2$schedule2.timezone;
    if (enabled) {
      this._uploadLastHashJob = (0, _cron.createSchedule)(cron, timezone).createJob(() => this._uploadLastHash().catch(log.error));
    }
    this._auditCore = undefined;
    this._storage = undefined;
    this._listeners = {
      'xo:audit': this._handleEvent.bind(this),
      'xo:postCall': this._handleEvent.bind(this, 'apiCall')
    };
  }
  configure({
    active = false
  }, {
    loaded
  }) {
    this._active = active;
    if (loaded) {
      this._addListeners();
    }
  }
  load() {
    var _this5 = this;
    return _asyncToGenerator(function* () {
      const storage = _this5._storage = new Db(yield _this5._xo.getStore(NAMESPACE));
      _this5._auditCore = new _auditCore.AuditCore(storage);
      const cleaners = _this5._cleaners;
      cleaners.push(() => {
        _this5._auditCore = undefined;
        _this5._storage = undefined;
      });
      _this5._addListeners();
      const exportRecords = _this5._exportRecords.bind(_this5);
      exportRecords.permission = 'admin';
      const getRecords = _this5._getRecords.bind(_this5);
      getRecords.description = 'Get records from a passed record ID';
      getRecords.permission = 'admin';
      getRecords.params = {
        id: {
          type: 'string',
          optional: true
        },
        maxRecords: {
          type: ['number', 'null'],
          optional: true
        },
        ndjson: {
          type: 'boolean',
          optional: true
        }
      };
      const checkIntegrity = _this5._checkIntegrity.bind(_this5);
      checkIntegrity.description = 'Check records integrity between oldest and newest';
      checkIntegrity.permission = 'admin';
      checkIntegrity.params = {
        newest: {
          type: 'string',
          optional: true
        },
        oldest: {
          type: 'string',
          optional: true
        }
      };
      const generateFingerprint = _this5._generateFingerprint.bind(_this5);
      generateFingerprint.description = 'Generate a fingerprint of the chain oldest-newest';
      generateFingerprint.permission = 'admin';
      generateFingerprint.params = {
        newest: {
          type: 'string',
          optional: true
        },
        oldest: {
          type: 'string',
          optional: true
        }
      };
      const uploadLastHashJob = _this5._uploadLastHashJob;
      if (uploadLastHashJob !== undefined) {
        uploadLastHashJob.start();
        cleaners.push(() => uploadLastHashJob.stop());
      }
      const clean = _this5._storage.clean.bind(_this5._storage);
      clean.permission = 'admin';
      clean.description = 'Clean audit database';
      const deleteRange = _this5._deleteRangeAndRewrite.bind(_this5);
      deleteRange.description = 'Delete a range of records and rewrite the records chain';
      deleteRange.permission = 'admin';
      deleteRange.params = {
        newest: {
          type: 'string'
        },
        oldest: {
          type: 'string',
          optional: true
        }
      };
      cleaners.push(_this5._xo.addApiMethods({
        audit: {
          checkIntegrity,
          clean,
          deleteRange,
          exportRecords,
          generateFingerprint,
          getRecords
        }
      }));
    })();
  }
  unload() {
    this._removeListeners();
    this._cleaners.forEach(cleaner => cleaner());
    this._cleaners.length = 0;
  }
  _addListeners(event, listener_) {
    this._removeListeners();
    if (this._active) {
      const listeners = this._listeners;
      Object.keys(listeners).forEach(event => {
        this._xo.addListener(event, listeners[event]);
      });
    }
  }
  _removeListeners() {
    const listeners = this._listeners;
    Object.keys(listeners).forEach(event => {
      this._xo.removeListener(event, listeners[event]);
    });
  }
  _handleEvent(event, _ref3) {
    var _this6 = this;
    return _asyncToGenerator(function* () {
      let userId = _ref3.userId,
        userIp = _ref3.userIp,
        userName = _ref3.userName,
        data = _objectWithoutProperties(_ref3, _excluded);
      try {
        if (event !== 'apiCall' || !_this6._blockedList[data.method]) {
          return yield _this6._auditCore.add({
            userId,
            userIp,
            userName
          }, event, data);
        }
      } catch (error) {
        log.error(error);
      }
    })();
  }
  _getRecords({
    id,
    maxRecords = 10e3,
    ndjson = false
  }) {
    var _this7 = this;
    return _asyncToGenerator(function* () {
      if (ndjson) {
        return _this7._xo.registerHttpRequest((req, res) => {
          res.set('Content-Type', 'application/json');
          return (0, _promiseToolbox.fromCallback)(_readableStream.pipeline, _this7._getRecordsStream(id, maxRecords === null ? undefined : maxRecords), res);
        }).then($getFrom => ({
          $getFrom
        }));
      }
      const records = [];
      var _iteratorAbruptCompletion = false;
      var _didIteratorError = false;
      var _iteratorError;
      try {
        for (var _iterator = _asyncIterator(_this7._auditCore.getFrom(id)), _step; _iteratorAbruptCompletion = !(_step = yield _iterator.next()).done; _iteratorAbruptCompletion = false) {
          const record = _step.value;
          {
            records.push(record);
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (_iteratorAbruptCompletion && _iterator.return != null) {
            yield _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
      return records;
    })();
  }
  _exportRecords() {
    return this._xo.registerHttpRequest((req, res) => {
      res.set({
        'content-disposition': 'attachment',
        'content-type': 'application/x-gzip'
      });
      return (0, _promiseToolbox.fromCallback)(_readableStream.pipeline, this._getRecordsStream(), (0, _zlib.createGzip)(), res);
    }, undefined, {
      suffix: `/audit-records-${new Date().toISOString().replace(/:/g, '_')}.ndjson.gz`
    }).then($getFrom => ({
      $getFrom
    }));
  }
  _uploadLastHash() {
    var _this8 = this;
    return _asyncToGenerator(function* () {
      const xo = _this8._xo;
      if (xo.audit === undefined) {
        return;
      }
      const lastRecordId = yield _this8._storage.getLastId();
      if (lastRecordId === undefined) {
        return;
      }
      const chain = yield xo.audit.getLastChain();
      let lastValidHash;
      if (chain !== null) {
        const hashes = chain.hashes;
        lastValidHash = hashes[hashes.length - 1];
        if (lastValidHash === lastRecordId) {
          return;
        }
        try {
          for (let i = 0; i < hashes.length - 1; ++i) {
            yield _this8._checkIntegrity({
              oldest: hashes[i],
              newest: hashes[i + 1]
            });
          }
        } catch (error) {
          if (!_apiErrors.missingAuditRecord.is(error) && !_apiErrors.alteredAuditRecord.is(error)) {
            throw error;
          }
          lastValidHash = undefined;
        }
      }
      const _yield$_this8$_genera = yield _this8._generateFingerprint({
          oldest: lastValidHash
        }),
        oldest = _yield$_this8$_genera.oldest,
        newest = _yield$_this8$_genera.newest,
        error = _yield$_this8$_genera.error;
      if (lastValidHash === undefined || error !== undefined) {
        yield xo.audit.startNewChain({
          oldest,
          newest
        });
      } else {
        yield xo.audit.extendLastChain({
          oldest,
          newest
        });
      }
    })();
  }
  _checkIntegrity(props) {
    var _this9 = this;
    return _asyncToGenerator(function* () {
      const _props$oldest = props.oldest,
        oldest = _props$oldest === void 0 ? _auditCore.NULL_ID : _props$oldest,
        _props$newest = props.newest,
        newest = _props$newest === void 0 ? yield _this9._storage.getLastId() : _props$newest;
      return _this9._auditCore.checkIntegrity(oldest, newest).catch(error => {
        if (error instanceof _auditCore.MissingRecordError) {
          throw (0, _apiErrors.missingAuditRecord)(error);
        }
        if (error instanceof _auditCore.AlteredRecordError) {
          throw (0, _apiErrors.alteredAuditRecord)(error);
        }
        throw error;
      });
    })();
  }
  _generateFingerprint(props) {
    var _this10 = this;
    return _asyncToGenerator(function* () {
      var _yield$_this10$_stora;
      const _props$oldest2 = props.oldest,
        oldest = _props$oldest2 === void 0 ? _auditCore.NULL_ID : _props$oldest2,
        _props$newest2 = props.newest,
        newest = _props$newest2 === void 0 ? (_yield$_this10$_stora = yield _this10._storage.getLastId()) !== null && _yield$_this10$_stora !== void 0 ? _yield$_this10$_stora : _auditCore.NULL_ID : _props$newest2;
      try {
        return {
          fingerprint: `${oldest}|${newest}`,
          newest,
          nValid: newest !== _auditCore.NULL_ID ? yield _this10._checkIntegrity({
            oldest,
            newest
          }) : 0,
          oldest
        };
      } catch (error) {
        if (_apiErrors.missingAuditRecord.is(error) || _apiErrors.alteredAuditRecord.is(error)) {
          return {
            error,
            fingerprint: `${error.data.id}|${newest}`,
            newest,
            nValid: error.data.nValid,
            oldest: error.data.id
          };
        }
        throw error;
      }
    })();
  }
  _deleteRangeAndRewrite({
    newest,
    oldest = newest
  }) {
    var _this11 = this;
    return _asyncToGenerator(function* () {
      yield _this11._auditCore.deleteRangeAndRewrite(newest, oldest);
      if (_this11._uploadLastHashJob !== undefined) {
        yield _this11._uploadLastHash();
      }
    })();
  }
}
AuditXoPlugin.prototype._getRecordsStream = (0, _asyncIteratorToStream.default)(function () {
  var _ref = _wrapAsyncGenerator(function* (id, maxRecords = Infinity) {
    var _iteratorAbruptCompletion2 = false;
    var _didIteratorError2 = false;
    var _iteratorError2;
    try {
      for (var _iterator2 = _asyncIterator(this._auditCore.getFrom(id)), _step2; _iteratorAbruptCompletion2 = !(_step2 = yield _awaitAsyncGenerator(_iterator2.next())).done; _iteratorAbruptCompletion2 = false) {
        const record = _step2.value;
        {
          if (--maxRecords < 0) {
            break;
          }
          yield JSON.stringify(record);
          yield '\n';
        }
      }
    } catch (err) {
      _didIteratorError2 = true;
      _iteratorError2 = err;
    } finally {
      try {
        if (_iteratorAbruptCompletion2 && _iterator2.return != null) {
          yield _awaitAsyncGenerator(_iterator2.return());
        }
      } finally {
        if (_didIteratorError2) {
          throw _iteratorError2;
        }
      }
    }
  });
  return function (_x) {
    return _ref.apply(this, arguments);
  };
}());
var _default = opts => new AuditXoPlugin(opts);
exports.default = _default;
//# sourceMappingURL=index.js.map