"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.configurationSchema = void 0;
var _passportGithub = require("passport-github");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
const configurationSchema = {
  type: 'object',
  properties: {
    clientID: {
      type: 'string'
    },
    clientSecret: {
      type: 'string'
    }
  },
  required: ['clientID', 'clientSecret']
};
exports.configurationSchema = configurationSchema;
class AuthGitHubXoPlugin {
  constructor(xo) {
    this._unregisterPassportStrategy = undefined;
    this._xo = xo;
  }
  configure(conf, {
    loaded
  }) {
    var _this = this;
    return _asyncToGenerator(function* () {
      _this._conf = conf;
      if (loaded) {
        yield _this.unload();
        yield _this.load();
      }
    })();
  }
  load() {
    const xo = this._xo;
    this._unregisterPassportStrategy = xo.registerPassportStrategy(new _passportGithub.Strategy(this._conf, function () {
      var _ref = _asyncToGenerator(function* (accessToken, refreshToken, profile, done) {
        try {
          done(null, yield xo.registerUser('github', profile.username));
        } catch (error) {
          done(error.message);
        }
      });
      return function (_x, _x2, _x3, _x4) {
        return _ref.apply(this, arguments);
      };
    }()));
  }
  unload() {
    this._unregisterPassportStrategy();
  }
}
var _default = ({
  xo
}) => new AuthGitHubXoPlugin(xo);
exports.default = _default;
//# sourceMappingURL=index.js.map