"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.configurationSchema = void 0;
var _passportGoogleOauth = require("passport-google-oauth20");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
const configurationSchema = {
  type: 'object',
  properties: {
    callbackURL: {
      type: 'string',
      description: 'Must be exactly the same as specified on the Google developer console.'
    },
    clientID: {
      type: 'string'
    },
    clientSecret: {
      type: 'string'
    },
    scope: {
      default: 'https://www.googleapis.com/auth/plus.login',
      description: 'Note that changing this value will break existing users.',
      enum: ['https://www.googleapis.com/auth/plus.login', 'email'],
      enumNames: ['Google+ name', 'Simple email address']
    }
  },
  required: ['callbackURL', 'clientID', 'clientSecret']
};
exports.configurationSchema = configurationSchema;
class AuthGoogleXoPlugin {
  constructor({
    xo
  }) {
    this._conf = null;
    this._unregisterPassportStrategy = undefined;
    this._xo = xo;
  }
  configure(conf, {
    loaded
  }) {
    var _this = this;
    return _asyncToGenerator(function* () {
      _this._conf = conf;
      if (loaded) {
        yield _this.unload();
        yield _this.load();
      }
    })();
  }
  load() {
    const conf = this._conf;
    const xo = this._xo;
    this._unregisterPassportStrategy = xo.registerPassportStrategy(new _passportGoogleOauth.Strategy(conf, function () {
      var _ref = _asyncToGenerator(function* (accessToken, refreshToken, profile, done) {
        try {
          done(null, yield xo.registerUser('google', conf.scope === 'email' ? profile.emails[0].value : profile.displayName));
        } catch (error) {
          done(error.message);
        }
      });
      return function (_x, _x2, _x3, _x4) {
        return _ref.apply(this, arguments);
      };
    }()));
  }
  unload() {
    this._unregisterPassportStrategy();
  }
}
var _default = opts => new AuthGoogleXoPlugin(opts);
exports.default = _default;
//# sourceMappingURL=index.js.map