#!/usr/bin/env node
"use strict";

var _execPromise = _interopRequireDefault(require("exec-promise"));
var _console = _interopRequireDefault(require("@xen-orchestra/log/transports/console"));
var _configure = require("@xen-orchestra/log/configure");
var _promiseToolbox = require("promise-toolbox");
var _fs = require("fs");
var _promptSchema = _interopRequireWildcard(require("./prompt-schema"));
var _ = _interopRequireWildcard(require("./"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const CACHE_FILE = './ldap.cache.conf';
(0, _execPromise.default)(async args => {
  var _process$env$DEBUG;
  const config = await (0, _promptSchema.default)(_.configurationSchema, await (0, _promiseToolbox.fromCallback)(_fs.readFile, CACHE_FILE, 'utf-8').then(JSON.parse, () => ({})));
  await (0, _promiseToolbox.fromCallback)(cb => (0, _fs.writeFile)(CACHE_FILE, JSON.stringify(config, null, 2), cb)).then(() => {
    console.log('configuration saved in %s', CACHE_FILE);
  }, error => {
    console.warn('failed to save configuration in %s', CACHE_FILE);
    console.warn(error.message);
  });
  (0, _configure.configure)([{
    filter: (_process$env$DEBUG = process.env.DEBUG) !== null && _process$env$DEBUG !== void 0 ? _process$env$DEBUG : 'xo:xo-server-auth-ldap',
    transport: (0, _console.default)()
  }]);
  const plugin = (0, _.default)();
  await plugin.configure(config);
  await plugin._authenticate({
    username: await (0, _promptSchema.input)('Username', {
      validate: input => !!input.length
    }),
    password: await (0, _promptSchema.password)('Password')
  });
});
//# sourceMappingURL=test-cli.js.map