"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.configurationSchema = void 0;
var _fromEvent = _interopRequireDefault(require("promise-toolbox/fromEvent"));
var _nodeXmppClient = _interopRequireDefault(require("node-xmpp-client"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
const configurationSchema = {
  type: 'object',
  properties: {
    host: {
      type: 'string',
      description: 'host where the XMPP server is located'
    },
    port: {
      type: 'integer',
      description: 'port of the XMPP server (default to 5222)',
      default: 5222
    },
    jid: {
      type: 'string',
      title: 'user',
      description: 'Xmpp address to use to authenticate'
    },
    password: {
      type: 'string',
      description: 'password to use to authenticate'
    }
  },
  additionalProperties: false,
  required: ['jid', 'password']
};
exports.configurationSchema = configurationSchema;
class TransportXmppPlugin {
  constructor({
    xo
  }) {
    this._sendToXmppClient = this._sendToXmppClient.bind(this);
    this._set = xo.defineProperty.bind(xo);
    this._unset = null;
    this._conf = null;
    this._client = null;
  }
  configure(conf) {
    this._conf = conf;
    this._conf.reconnect = true;
  }
  load() {
    var _this = this;
    return _asyncToGenerator(function* () {
      _this._client = new _nodeXmppClient.default(_this._conf);
      _this._client.on('error', () => {});
      yield (0, _fromEvent.default)(_this._client.connection.socket, 'data');
      yield (0, _fromEvent.default)(_this._client, 'online');
      _this._unset = _this._set('sendToXmppClient', _this._sendToXmppClient);
    })();
  }
  unload() {
    this._unset();
    this._client.end();
    this._unset = this._client = null;
  }
  _sendToXmppClient({
    to,
    message
  }) {
    var _iterator = _createForOfIteratorHelper(to),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        const receiver = _step.value;
        this._client.send(new _nodeXmppClient.default.Stanza('message', {
          to: receiver,
          type: 'chat'
        }).c('body').t(message));
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }
}
var _default = opts => new TransportXmppPlugin(opts);
exports.default = _default;
//# sourceMappingURL=index.js.map