const IPV4_KEY_RE = /^\d+\/ip(?:v4\/\d+)?$/;
const IPV6_KEY_RE = /^\d+\/ipv6\/\d+$/;
export const extractIpFromVmNetworks = networks => {
  if (networks === undefined) {
    return;
  }
  let ipv6;
  for (const key of Object.keys(networks).sort()) {
    if (IPV4_KEY_RE.test(key)) {
      return networks[key];
    }
    if (ipv6 === undefined && IPV6_KEY_RE.test(key)) {
      ipv6 = networks[key];
    }
  }
  return ipv6;
};
//# sourceMappingURL=_extractIpFromVmNetworks.mjs.map