import tap from 'tap';
import normalizeVmNetworks from './_normalizeVmNetworks.mjs';
tap.test('normalizeVmNetworks', async t => {
  t.strictSame(normalizeVmNetworks({
    '0/ip': '127.0.0.1 127.0.0.2',
    '0/ipv4/0': '127.0.0.1',
    '1/ip': '127.0.0.1',
    '0/ipv4/2': '127.0.0.4',
    '0/ipv4/1': '127.0.0.5',
    '0/ipv4/foo bar': '127.0.0.3',
    '0/ipv6/0': '::1',
    '0/ipv4/3': '   ',
    '2/ipv5/0': '127.0.0.1'
  }), {
    '0/ipv4/0': '127.0.0.1',
    '0/ipv4/1': '127.0.0.2',
    '0/ipv4/2': '127.0.0.5',
    '0/ipv4/3': '127.0.0.4',
    '0/ipv4/4': '127.0.0.3',
    '0/ipv6/0': '::1',
    '1/ipv4/0': '127.0.0.1'
  });
});
//# sourceMappingURL=_normalizeVmNetworks.spec.mjs.map