import assert from 'assert/strict';
import tap from 'tap';
import { debounceWithKey, REMOVE_CACHE_ENTRY } from './_pDebounceWithKey.mjs';
const {
  describe,
  it
} = tap.mocha;
describe('REMOVE_CACHE_ENTRY', () => {
  it('clears the cache', async () => {
    let i = 0;
    const debouncedFn = debounceWithKey(function () {
      return Promise.resolve(++i);
    }, Infinity, id => id);
    assert.equal(await debouncedFn(1), 1);
    assert.equal(await debouncedFn(2), 2);
    assert.equal(await debouncedFn(1), 1);
    assert.equal(await debouncedFn(2), 2);
    debouncedFn(REMOVE_CACHE_ENTRY, 1);
    assert.equal(await debouncedFn(1), 3);
    assert.equal(await debouncedFn(2), 2);
  });
});
//# sourceMappingURL=_pDebounceWithKey.spec.mjs.map