#!/usr/bin/env node
import * as SourceMapSupport from 'source-map-support';
import Bluebird from 'bluebird';
import execPromise from 'exec-promise';
import { catchGlobalErrors } from '@xen-orchestra/log/configure';
import { createCachedLookup } from '@vates/cached-dns.lookup';
import { createLogger } from '@xen-orchestra/log';
import main from './index.mjs';
if (process.env.NODE_ENV === undefined) {
  process.env.NODE_ENV = 'production';
}
try {
  SourceMapSupport.install({
    handleUncaughtExceptions: false
  });
} catch (_) {}
Bluebird.config({
  asyncHooks: true
});
global.Promise = Bluebird;
catchGlobalErrors(createLogger('xo:xo-server'));
createCachedLookup().patchGlobal();
execPromise(main);
//# sourceMappingURL=cli.mjs.map