import { EventEmitter } from 'events';
import { noop } from './utils.mjs';
export default class Connection extends EventEmitter {
  constructor() {
    super();
    this._data = {
      __proto__: null
    };
  }
  close() {
    this.close = noop;
    this.emit('close');
  }
  get(key, defaultValue) {
    const {
      _data: data
    } = this;
    if (key in data) {
      return data[key];
    }
    if (arguments.length >= 2) {
      return defaultValue;
    }
    throw new Error('no value for `' + key + '`');
  }
  has(key) {
    return key in this._data;
  }
  set(key, value) {
    this._data[key] = value;
  }
  unset(key) {
    delete this._data[key];
  }
}
//# sourceMappingURL=connection.mjs.map