const _combine = (vectors, n, cb) => {
  if (!n) {
    return;
  }
  const nLast = n - 1;
  const vector = vectors[nLast];
  const m = vector.length;
  if (n === 1) {
    for (let i = 0; i < m; ++i) {
      cb([vector[i]]);
    }
    return;
  }
  for (let i = 0; i < m; ++i) {
    const value = vector[i];
    _combine(vectors, nLast, vector => {
      vector.push(value);
      cb(vector);
    });
  }
};
export const combine = vectors => cb => _combine(vectors, vectors.length, cb);
export const mergeObjects = objects => Object.assign({}, ...objects);
export const crossProduct = (vectors, mergeFn = mergeObjects) => cb => combine(vectors)(vector => {
  cb(mergeFn(vector));
});
//# sourceMappingURL=math.mjs.map