import hrp from 'http-request-plus';
import ProxyAgent from 'proxy-agent';
const {
  env
} = process;
export default class Http {
  _agent = new ProxyAgent();
  get hasOwnHttpProxy() {
    return this._hasOwnHttpProxy;
  }
  get httpAgent() {
    return this._agent;
  }
  constructor(app) {
    app.config.watch(({
      httpProxy,
      noProxy
    }) => {
      if (httpProxy !== undefined) {
        this._hasOwnHttpProxy = true;
        this.setHttpProxy(httpProxy, noProxy);
      }
    });
  }
  httpRequest(url, opts) {
    return hrp(url, {
      ...opts,
      agent: this._agent
    });
  }
  setHttpProxy(proxy, noProxy) {
    if (proxy == null) {
      delete env.http_proxy;
      delete env.HTTP_PROXY;
      delete env.https_proxy;
      delete env.HTTPS_PROXY;
    } else {
      env.http_proxy = env.HTTP_PROXY = env.https_proxy = env.HTTPS_PROXY = proxy;
    }
    if (noProxy !== undefined) {
      if (proxy === null) {
        delete env.no_proxy;
        delete env.NO_PROXY;
      } else {
        env.no_proxy = env.NO_PROXY = noProxy;
      }
    }
  }
}
//# sourceMappingURL=http.mjs.map